//+------------------------------------------------------------------+
//|                                                           VQ.mq4 |
//|                                               Volatility Quality |
//|                                                by raff1410@o2.pl |
//|                      Modified for use by EA's by Big Be, Jan. 08 |
//+------------------------------------------------------------------+

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  Yellow
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Yellow
#property  indicator_color5  Cyan
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2

extern   bool     Crash = false;

extern   int      TimeFrame = 0;
extern   int      Length = 5; // number of bars lookback
extern   int      Method = 3; //for MA's
extern   int      Smoothing = 1;
extern   int      Filter = 5;  //step size

extern   bool     RealTime = true;
extern   bool     Steady  = false; //uses Median Price not Close
extern   bool     Color = true;
extern   bool     Alerts = true;
extern   bool     EmailON = false;
extern   bool     SignalPrice = true;
extern   color    SignalPriceBUY = DarkGreen;
extern   color    SignalPriceSELL = Aquamarine;
extern   int      CountBars = 50;//originally set to 1485, try 100,000 to 200,000 for indicator to look across many bars


double   VQ[];
double   SumVQ[];
double   SumVQ_MTF[];
double   DIR[];
double   UpBuffer[];
double   DnBuffer[];
double   UpArrow[];
double   DnArrow[];

bool     TurnedUp = false;
bool     TurnedDn = false;
datetime timeprev1=0;
datetime timeprev2=0;
int p=0;
//+------------------------------------------------------------------+

int init()
{
IndicatorBuffers(8);
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
SetIndexBuffer(0,SumVQ);
SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
SetIndexBuffer(1,UpBuffer);
SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
SetIndexBuffer(2,DnBuffer);
SetIndexStyle(3,DRAW_ARROW);
SetIndexArrow(3,233);
SetIndexBuffer(3,UpArrow);
SetIndexStyle(4,DRAW_ARROW);
SetIndexArrow(4,234);
SetIndexBuffer(4,DnArrow);
SetIndexBuffer(5,VQ);
SetIndexBuffer(6,DIR);
SetIndexBuffer(7,SumVQ_MTF);

if (Length < 2) Length = 2;
if (Method < 0) Method = 0;
if (Method > 3) Method = 3;
if (Smoothing < 0) Smoothing = 0;  //Shift
if (Filter < 0) Filter = 0;


if ((TimeFrame < Period()) && (TimeFrame != 0)) TimeFrame = Period();

return(0);
}

//+------------------------------------------------------------------+

int start()
{

if (Bars < 100) {IndicatorShortName("Bars less than 100"); return(0);}

if(timeprev1<iTime(NULL,TimeFrame,0)) {TurnedDn = false; TurnedUp = false; timeprev1=iTime(NULL,TimeFrame,0);}

if (!RealTime)
{
   if(timeprev2==iTime(NULL,TimeFrame,0)) return(0);
   timeprev2=iTime(NULL,TimeFrame,0);
   p=TimeFrame/Period()+1; if (p==0) p=1;
}
//--------------------------------------------------------------------------------//
double TR = 0, MH = 0, ML = 0, MO = 0, MC = 0, MC1 = 0;

if (CountBars>iBars(NULL,TimeFrame) || CountBars>Bars-Length-1) 
   CountBars=MathMin(Bars-Length-1,iBars(NULL,TimeFrame)-Length-1);
if (Crash && CountBars>0){CountBars=CountBars-10; IndicatorShortName("Crash: "+CountBars+"     ");}
if (Crash && CountBars<0) IndicatorShortName("Crash");

int i = CountBars;
SumVQ[i + 1] =   Close[i + 1];          
//SumVQ_MTF[i + 1] = Close[i + 1];        
while (i >= 0)
   {
   MH = iMA(NULL,TimeFrame,Length,0,Method,PRICE_HIGH,i);
   ML = iMA(NULL,TimeFrame,Length,0,Method,PRICE_LOW,i);
   MO = iMA(NULL,TimeFrame,Length,0,Method,PRICE_OPEN,i);
   MC = iMA(NULL,TimeFrame,Length,0,Method,PRICE_CLOSE,i);
   MC1 = iMA(NULL,TimeFrame,Length,0,Method,PRICE_CLOSE,i + Smoothing);
   if (Steady==true) 
      {MC=iMA(NULL,TimeFrame,Length,0,Method,PRICE_MEDIAN,i); 
      MC1=iMA(NULL,TimeFrame,Length,0,Method,PRICE_MEDIAN,i+Smoothing);}
   VQ[i] = MathAbs(((MC - MC1) / 
      MathMax(MH - ML,MathMax(MH - MC1,MC1 - ML)) + (MC - MO) / (MH - ML)) * 0.5) * ((MC - MC1 + (MC - MO)) * 0.5);
   SumVQ[i] = SumVQ[i + 1] + VQ[i];
   if (Filter > 0) 
      if (MathAbs(SumVQ[i] - SumVQ[i + 1]) < Filter * Point) 
      SumVQ[i] = SumVQ[i + 1];
//   if (TimeFrame > Period()) 
//      SumVQ_MTF[i] = SumVQ[i];
   i--;
   }


for (i = CountBars; i >= 0; i--)
   {
   DIR[i] = DIR[i + 1];
   if (SumVQ[i] - SumVQ[i + 1] > 0) DIR[i] = 1;
   if (SumVQ[i + 1] - SumVQ[i] > 0) DIR[i] = -1;
   if (Color == true)
      {
      if (DIR[i] > 0)
         {
         UpBuffer[i] = SumVQ[i];
       //  if (DIR[i + 1] < 0) UpBuffer[i + 1] = SumVQ[i + 1]; // DO NOT use for EA - causes lag
         DnBuffer[i] = EMPTY_VALUE;
         }
         else
         {
         if (DIR[i] < 0)
            {
            DnBuffer[i] = SumVQ[i];
          //  if (DIR[i + 1] > 0) DnBuffer[i + 1] = SumVQ[i + 1]; // DO NOT use for EA
            UpBuffer[i] = EMPTY_VALUE;
            }
         }
      }
   if (Alerts == true)
      {
      UpArrow[i] = EMPTY_VALUE; DnArrow[i] = EMPTY_VALUE;
      if ((DIR[i] == 1) && (DIR[i + 1] == -1)) UpArrow[i] = SumVQ[i + 1] - (Ask - Bid);
      if ((DIR[i] == -1) && (DIR[i + 1] == 1)) DnArrow[i] = SumVQ[i + 1] + (Ask - Bid);
      }
   }
   
   
         
return(0);
}